/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 131
#ifdef HAVE_CONFIG_H
#line 131
# include <config.h>
#line 131
#endif
#line 131
#include <sys/types.h>
#line 131

#line 131
#include "mailfromd.h"
#line 131
#include "prog.h"
#line 131
#include "builtin.h"
#line 131

#line 131

#line 767 "../../src/builtin/snarf.m4"

#line 1 "sieve.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2007-2011, 2015-2016 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <mailutils/mailutils.h>
#include <mflib/sieve.h>
#include "msg.h"

static void
_sieve_text_action_log(void *env_ptr,
		       mu_stream_t stream, size_t msgno,
		       mu_message_t msg,
		       const char *action, const char *fmt, va_list ap)
{
	eval_environ_t env = env_ptr;
	const char *id;
	
	mu_stream_printf(stream, "\033s<%d>", MU_LOG_NOTICE);
	id = mailfromd_msgid(env_get_context(env));
	if (id && id[0])
		/* ID includes trailing semicolon */
		mu_stream_printf(stream, "%s", id);
	mu_stream_printf(stream, "%s", action);
	if (fmt && fmt[0]) {
		mu_stream_printf(stream, "; ");
		mu_stream_vprintf(stream, fmt, ap);
	}
	mu_stream_printf(stream, "\n");
}

static void
_sieve_file_action_log(void *env_ptr,
		       mu_stream_t stream, size_t msgno,
		       mu_message_t msg,
		       const char *action, const char *fmt, va_list ap)
{
	eval_environ_t env = env_ptr;
	struct locus locus;

	_sieve_text_action_log(env_ptr, stream, msgno, msg, action, fmt, ap);

	env_get_locus(env, &locus);
	mu_stream_printf(stream, "\033f<%lu>%s\033l<%lu>\033s<%d>\033O<%d>%s\n",
			 (unsigned long) strlen(locus.file), locus.file,
			 locus.line,
			 MU_LOG_NOTICE,
		         MU_LOGMODE_LOCUS|MU_LOGMODE_SEVERITY,
			 _("sieve called from here"));
}

static void
mach_cleanup(void *ptr)
{
	mu_sieve_machine_t mach = ptr;
	mu_sieve_machine_destroy(&mach);
}

void
#line 70
bi_sieve(eval_environ_t env)
#line 70

#line 70

#line 70 "sieve.bi"
{
#line 70
	
#line 70

#line 70
long __bi_argcnt;
#line 70
long  nmsg;
#line 70
        char *  script;
#line 70
        long  flags;
#line 70
        char *  file;
#line 70
        long  line;
#line 70
        
#line 70
get_numeric_arg(env, 1, &nmsg);
#line 70
        get_string_arg(env, 2, &script);
#line 70
        get_numeric_arg(env, 3, &flags);
#line 70
        get_string_arg(env, 4, &file);
#line 70
        get_numeric_arg(env, 5, &line);
#line 70
        
#line 70
get_numeric_arg(env, 0, &__bi_argcnt);
#line 70
        adjust_stack(env, __bi_argcnt + 1);
#line 70

#line 70

#line 70
	if (builtin_module_trace(BUILTIN_IDX_sieve))
#line 70
		prog_trace(env, "sieve %lu %s %lu %s %lu",nmsg, script, ((__bi_argcnt > 2) ? flags : 0), ((__bi_argcnt > 3) ? file : ""), ((__bi_argcnt > 4) ? line : 0));;

{
	mu_sieve_machine_t mach;
	int sieve_debug_flags = 0;
	int rc;
	int retval = 0;
	int f = ((__bi_argcnt > 2) ? flags : 0);
	mu_attribute_t attr;
	mu_message_t msg;

	rc = mu_sieve_machine_init(&mach);
		if (!(rc == 0))
#line 82
		(
#line 82
	env_throw_bi(env, mfe_failure, "sieve", _("failed to initialize sieve machine: %s"),mu_strerror(rc))
#line 82
)
#line 84
;
	env_function_cleanup_add(env, mach, mach_cleanup);
	
	if (f & MF_SIEVE_DEBUG_TRACE)
		sieve_debug_flags |= MU_SIEVE_DEBUG_TRACE;
	if (f & MF_SIEVE_DEBUG_INSTR)
		sieve_debug_flags |= MU_SIEVE_DEBUG_INSTR;

	mu_sieve_set_debug_level(mach, sieve_debug_flags);

	mu_sieve_set_data(mach, env);

	if (f & MF_SIEVE_TEXT) {
		struct locus locus;

		env_get_locus(env, &locus);
		if (f & MF_SIEVE_LOG)
			mu_sieve_set_logger(mach, _sieve_text_action_log);
		rc = mu_sieve_compile_buffer(mach, script, strlen(script),
					     ((__bi_argcnt > 3) ? file : locus.file),
					     ((__bi_argcnt > 4) ? line : locus.line));
	} else {
		if (f & MF_SIEVE_LOG)
			mu_sieve_set_logger(mach, _sieve_file_action_log);
		rc = mu_sieve_compile(mach, script);
	}

		if (!(rc == 0))
#line 111
		(
#line 111
	env_throw_bi(env, mfe_failure, "sieve", _("compilation of Sieve script %s failed"),script)
#line 111
)
#line 114
;

	msg = bi_message_from_descr(env, nmsg);
		
	mu_message_get_attribute(msg, &attr);
	mu_attribute_unset_deleted(attr);
	rc = mu_sieve_message(mach, msg);
		if (!(rc == 0))
#line 121
		(
#line 121
	env_throw_bi(env, mfe_failure, "sieve", _("sieving failed: %s"),mu_strerror(rc))
#line 121
)
#line 124
;
	retval = !(mu_attribute_is_deleted(attr) == 0);

	
#line 127
do {
#line 127
  push(env, (STKVAL)(mft_number)(retval));
#line 127
  goto endlab;
#line 127
} while (0);
}
endlab:
#line 129
        env_function_cleanup_flush(env, NULL);
#line 129
	return;
#line 129
}


#line 131
void
#line 131
sieve_init_builtin()
#line 131
{
#line 131
	
#line 131
	#line 70 "sieve.bi"
va_builtin_install_ex("sieve", bi_sieve, 0, dtype_number, 5, 3, 0|0, dtype_number, dtype_string, dtype_number, dtype_string, dtype_number);

#line 131 "sieve.bi"
	
#line 131
}
#line 131 "sieve.bi"

#line 131

#line 761 "../../src/builtin/snarf.m4"

#line 761

